SimpleViewer = {};
update(SimpleViewer, {
     itemIndex: 0, 
     keybinds: {},
      
     init: function() {
        var self = this;
        this.items = map(function(li) {
          var a = li.firstChild;
          var viewArea = P({style: 'display:none'});
          li.appendChild(viewArea);
          var item = {
            'li': li,
            'a': a,
            'viewArea': viewArea,
            'loaded': false
          };
          connect(a, 'onclick', self, partial(self.toggleView, item));
          connect(item, 'toggle', self, partial(self.toggleView, item));
          return item;
        }, document.body.getElementsByTagName('li'));

        connect(document, 'onkeypress', this.keyListener);
        this.addKeybind('j', this.next);
        this.addKeybind('k', this.prev);
        this.addKeybind('o', this.toggle);
        this.focus();
      },

      toggleView: function(item, ev) {
          if(ev) ev.stop();
          if(item.loaded) {
              item.viewArea.style.display = 'none';
              item.loaded = false;
          } else {
              item.viewArea.style.display = 'block';
              item.loaded = true;
              var url = item.a.href;
              d = doSimpleXMLHttpRequest(url);
              d.addCallback(this.validation);
              d.addCallback(partial(this.view, item.viewArea));
              d.addErrback(partial(this.errView, item.viewArea));
          }
      },

      toggle: function() {
          signal(this.current(), 'toggle')
      },

      validation: function(res, d) {
          if (res.responseText.length == 0) {
              throw new MochiKit.Async.GenericError('テキストがありません');
          }
          return res;
      },

      errView: function(viewArea, e) {
          replaceChildNodes(viewArea, e.message);
          return e;
      },

      view: function(viewArea, res) {
          replaceChildNodes(viewArea, res.responseText);
          return res;
      },

      keyListener: function(ev) {
        var str = ev.key().string;
        if(this.keybinds[str])
            this.keybinds[str].apply(this)
      },

      addKeybind: function(char, func) {
          this.keybinds[char] = func;
      },

      current: function() {
          return this.items[this.itemIndex];
      },

      focus: function() {
          this.current().a.focus();
      },

      next: function() {
          if (this.itemIndex < this.items.length - 1) this.itemIndex++;
          this.focus();
      },

      prev: function() {
          if (this.itemIndex > 0) this.itemIndex--;
          this.focus();
      }
});

bindMethods(SimpleViewer);
connect(window, 'onload', SimpleViewer.init);

